#!/bin/bash

PATH=/sbin:/bin:/usr/bin:/usr/sbin

chown -R root:root /lib/modules

depmod -a >/dev/null 2>&1

# ATARAID / SATA drivers
#
LOAD_LIBATA=

LOAD_ATA_PIIX=
LOAD_SATA_NV=
LOAD_SATA_PROMISE=
LOAD_SATA_SIL=
LOAD_SATA_SIS=
LOAD_SATA_SVW=
LOAD_SATA_SX4=
LOAD_SATA_VIA=
LOAD_SATA_VSC=

LOAD_ATARAID=

LOAD_ISWRAID=

/etc/rc.d/pciprobe -m ata_piix && LOAD_LIBATA=1 && LOAD_ATA_PIIX=1 && LOAD_ATARAID=1 && LOAD_ISWRAID=1
/etc/rc.d/pciprobe -m sata_nv && LOAD_LIBATA=1 && LOAD_SATA_NV=1
/etc/rc.d/pciprobe -m sata_promise && LOAD_LIBATA=1 && LOAD_SATA_PROMISE=1
/etc/rc.d/pciprobe -m sata_sil && LOAD_LIBATA=1 && LOAD_SATA_SIL=1
/etc/rc.d/pciprobe -m sata_sis && LOAD_LIBATA=1 && LOAD_SATA_SIS=1
/etc/rc.d/pciprobe -m sata_svw && LOAD_LIBATA=1 && LOAD_SATA_SVW=1
/etc/rc.d/pciprobe -m sata_sx4 && LOAD_LIBATA=1 && LOAD_SATA_SX4=1
/etc/rc.d/pciprobe -m sata_via && LOAD_LIBATA=1 && LOAD_SATA_VIA=1
/etc/rc.d/pciprobe -m sata_vsc && LOAD_LIBATA=1 && LOAD_SATA_VSC=1

[ -n "${LOAD_LIBATA}"] && modprobe -a libata >/dev/null 2>&1

[ -n "${LOAD_ATA_PIIX}" ] && modprobe -a ata_piix >/dev/null 2>&1
[ -n "${LOAD_SATA_NV}" ] && modprobe -a sata_nv >/dev/null 2>&1
[ -n "${LOAD_SATA_PROMISE}" ] && modprobe -a sata_promise >/dev/null 2>&1
[ -n "${LOAD_SATA_SIL}" ] && modprobe -a sata_sil >/dev/null 2>&1
[ -n "${LOAD_SATA_SIS}" ] && modprobe -a sata_sis >/dev/null 2>&1
[ -n "${LOAD_SATA_SVW}" ] && modprobe -a sata_svw >/dev/null 2>&1
[ -n "${LOAD_SATA_SX4}" ] && modprobe -a sata_sx4 >/dev/null 2>&1
[ -n "${LOAD_SATA_VIA}" ] && modprobe -a sata_via >/dev/null 2>&1
[ -n "${LOAD_SATA_VSC}" ] && modprobe -a sata_vsc >/dev/null 2>&1

[ -n "${LOAD_ATARAID}"] && modprobe -a ataraid >/dev/null 2>&1

[ -n "${LOAD_ISWRAID}" ] && modprobe -a iswraid >/dev/null 2>&1

# Misc. SATA drivers
#
/etc/rc.d/pciprobe -m sx8 && modprobe -a sx8 >/dev/null 2>&1

# IDE, SCSI and RAID drivers
#
/etc/rc.d/pciprobe -m aic7xxx && modprobe -a aic7xxx > /dev/null 2>&1
/etc/rc.d/pciprobe -m aic79xx && modprobe -a aic79xx > /dev/null 2>&1
/etc/rc.d/pciprobe -m cciss && modprobe -a cciss > /dev/null 2>&1
/etc/rc.d/pciprobe -m cpqarray && modprobe -a cpqarray > /dev/null 2>&1
modprobe -a cpqfc > /dev/null 2>&1
modprobe -a sym53c8xxHP > /dev/null 2>&1
modprobe -a sym53c8xx > /dev/null 2>&1
modprobe -a megaide > /dev/null 2>&1
modprobe -a megaraid2 > /dev/null 2>&1
modprobe -a aacraid > /dev/null 2>&1
modprobe -a ips > /dev/null 2>&1
modprobe -a 3w-xxxx > /dev/null 2>&1
modprobe -a mptscsih > /dev/null 2>&1
modprobe -a aacraid aacraid_pciid=0x1028,0x000A,0x1028,0x0106 > /dev/null 2>&1
modprobe -a aacraid aacraid_pciid=0x1028,0x000A,0x1028,0x011B > /dev/null 2>&1
modprobe -a aacraid aacraid_pciid=0x1028,0x000A,0x1028,0x0121 > /dev/null 2>&1
modprobe -a BusLogic > /dev/null 2>&1

insmod usbcore  >/dev/null 2>&1
if [ -d /proc/bus/usb ]; then
 insmod input >/dev/null 2>&1
 insmod hid >/dev/null 2>&1
 insmod mousedev >/dev/null 2>&1
 insmod keybdev >/dev/null 2>&1
 insmod usb-ohci >/dev/null 2>&1
 insmod usb-uhci >/dev/null 2>&1
else
 rmmod usbcore >/dev/null 2>&1
fi

exit 0
